
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <malloc.h>

int tohex (char *s);

void main (int argc, char *argv[])
{
    char tabinp[256], tabout[256], buf[16], *b;
    int  inpt, outt, inpf, outf;
    int  i;
    long l;

    if (argc != 5) return;
    inpt = open (argv[1], O_BINARY|O_RDONLY);
    outt = open (argv[2], O_BINARY|O_RDONLY);
    inpf = open (argv[3], O_BINARY|O_RDONLY);
    outf = open (argv[4], O_CREAT|O_BINARY|O_WRONLY, S_IREAD|S_IWRITE);
    if (inpt < 0 || outt < 0 || inpf < 0 || outf < 0) return;

    printf ("reading tables...\n");
    for (i=0; i<=255; i++)
    {
       read (inpt, buf, 3);  tabinp[i] = tohex (buf);
       read (outt, buf, 3);  tabout[i] = tohex (buf);
    }
    close (inpt); close (outt);

    printf ("reading input file... ");
    l = filelength (inpf);
    printf ("%ld bytes long\n", l);
    b = malloc (l); if (b == NULL) return;
    if (read (inpf, b, l) != l) return;
    close (inpf);

    printf ("searching pattern... ");
    for (i=0; i<l-256-1; i++)
    {
       if (memcmp (b+i, tabinp, 256) == 0)
       {
          printf ("found at %d (0x%x)", i, i);
          memcpy (b+i, tabout, 256);
       }
    }

    printf ("\nwriting output file... ");
    if (write (outf, b, l) != l) printf ("write failed\n");
    close (outf);
    printf ("done");
}

int tohex (char *s)
{
   /*
   printf ("(%s,%c,%c,%d,%d)", s, s[0], s[1], 
           s[0]<='9' ? s[0]-'0' : s[0]-'A', s[1]<='9' ? s[1]-'0' : s[1]-'A');  
   */
   return (s[0]<='9' ? s[0]-'0' : s[0]-'A'+10) * 16 +
          (s[1]<='9' ? s[1]-'0' : s[1]-'A'+10);
}
